import java.awt.Color;
import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Black_Background here.
 * 
 * @author Matthew Milan 
 * @version .1
 */
public class Black_Background extends World
{
    private Color fadeColor = new Color(0,0,0);
    private Color baseColor = new Color(0,0,0);
    private Color myColor = new Color (0,200,200);

    private int whichColor = 0;
    private int shapeSize = 30;
    private boolean color1 = false;
    private int mouseColor;
    private boolean redScrollDown =true;
    private boolean redScrollActive =true;
    private boolean blueScrollDown =true;
    private boolean blueScrollActive =false;
    private boolean greenScrollActive =true;
    private boolean greenScrollDown =false;

    private MouseInfo mouseNew;
    private MouseInfo mouseOld;

    private int r;
    private int b;
    private int g;

    private static int particles = 0;
    /**
     * Constructor for objects of class Black_Background.
     * 
     */
    public Black_Background()
    {    
        super(600, 400, 1); 
        getBackground().setColor(Color.BLACK);
        getBackground().fill();
        mouseOld = Greenfoot.getMouseInfo();
        mouseColor = 0;
    }

    public void act()
    {
        mouseShootParticle();
        changeMouseColor();

    }

    public void changeMouseColor()
    {
        if (Greenfoot.mouseClicked(null))
        {
            removeObjects(getObjects(ColorParticle.class));
            
            mouseColor++;
            if (mouseColor >=3)
            {
                mouseColor = 0;
            }
        }
    }


    public void mouseShootParticle()
    {
        mouseNew = Greenfoot.getMouseInfo();
        if (mouseNew == null ) return;

        if (mouseOld != mouseNew)
        {
            if (!(mouseNew.getX() > getWidth() || mouseNew.getY() > getHeight()))
            {
                try {  
                    addObject(new ColorParticle(calculateMouseSpeed(), calculateMouseDirection(), mouseColor),
                        mouseNew.getX(),mouseNew.getY());
                } catch(Exception e) {}  
            }
            mouseOld = mouseNew;
        } else
        if (mouseOld == mouseNew)
        {
            //idleMouseParticles();
        }
    }

    public int calculateMouseSpeed()
    {
        return (int)(calculateMouseDistance() / 5);
    }

    public int calculateMouseDirection() throws Exception  
    {  
        return  (int)(180 * Math.atan2(mouseNew.getY() - mouseOld.getY(), mouseNew.getX() - mouseOld.getX()) / Math.PI);  
    }  

    public double calculateMouseDistance()
    {
        return Math.sqrt(Math.pow(mouseOld.getX() - mouseNew.getX(),2)
            + Math.pow(mouseOld.getY() - mouseNew.getY(),2));
    }

    public void mouseDraw()
    {
        mouseNew = Greenfoot.getMouseInfo();
        mouseOld = mouseNew;
        if (mouseNew == null) return;
        if (!(mouseNew.getX() > getWidth() || mouseNew.getY() > getHeight()))
        {
            getBackground().fillOval(mouseNew.getX() - (shapeSize / 2), 
                mouseNew.getY() - (shapeSize / 2), 
                shapeSize,shapeSize);            
        }
    }    

    public static void removeParticle()
    {
        particles--;
    }

}
