import java.awt.Color;
import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ColorParticle here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ColorParticle extends Actor
{

    private Color myColor;
    private GreenfootImage image;
    private GreenfootImage bgImage;
    private double newDistance;
    private boolean reversed;
    
    private int speed;
    private int mySize;
    private int myReversal;
    private final int MY_MAX_REVERSAL = 15;
    private int myMouseColor;
    private MouseInfo target;
    private int oldX;
    private int oldY;

    /**
     * Act - do whatever the ColorParticle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public ColorParticle(int newSpeed, int newDirection, int mouseColor)
    {
        myMouseColor = mouseColor;
        myReversal = MY_MAX_REVERSAL;
        reversed = false;
        if (myMouseColor == 0)
        {
            myColor = new Color(200,0,0,120);
        }
        else
        if (myMouseColor == 1)
        {
            myColor = new Color(0,200,0,120);
        }

        if (myMouseColor == 2)
        {
            myColor = new Color(0,0,200,120);            
        }
        speed = newSpeed;
        if (speed < 1)
        {
            speed = 1;
        }
        setRotation(newDirection);
        image = new GreenfootImage(200,200);

        setImage(image);
        mySize = 1;
    }

    /**
     * updates instance variables, counters, and refreshes target.
     * will remove particle if it's at world edge, or if it's too transparent
     * 
     */
    public void act() 
    {
        if (target!=null)
        {
            oldX = target.getX();
            oldY = target.getY();
        }
        target = Greenfoot.getMouseInfo();
        myReversal--;
        if (myReversal <= 0)
        {
            if (reversed)
            {
                reversed = false;
            }
            else
            {
                reversed = true;
            }
            myReversal = MY_MAX_REVERSAL;
        }
        travel();
        mySize++;
        drawOnBG();
        fade();
        if (atWorldEdge() || myColor.getAlpha() < 10)
        {
            getWorld().removeObject(this);
        }
    }    

    /**
     * updates the variable for distance between mouse and particle.
     * moves a combinatino of the initial speed variable, set upon creation, with a speed value
     * that increases when the distance increases
     * 
     * finally, faces towards or away from the mouse depending on the condition of
     * reversed boolean.
     * 
     * reverse is set in act.
     */
    public void travel()
    {
        findDistance();
        move( speed + (int)newDistance);
        setRotation(toFaceTarget(reversed));
    }

    /**
     * faces towards or away from mouse pointer.
     * has erratic behaviour, and not optimized.
     */
    
    public int toFaceTarget(boolean faceAt)  
    {  
        if(target != null && faceAt)  
        {  
            int xDiff = target.getX() - getX(),  
            yDiff = target.getY() - getY();  
            double angle = Math.toDegrees(Math.atan2(yDiff, xDiff));  
            return (int)Math.round(angle);  
        }  
        else 
        if (target == null && faceAt)
        {
            int xDiff = oldX - getX(),  
            yDiff = oldY - getY();  
            double angle = Math.toDegrees(Math.atan2(yDiff, xDiff));  
            return (int)Math.round(angle);              
        } else
        if(target != null && !faceAt)  
        {  
            int xDiff = target.getX() - getX(),  
            yDiff = target.getY() - getY();  
            double angle = Math.toDegrees(Math.atan2(yDiff, xDiff));  
            int beforeReversed = (int)Math.round(angle);
            beforeReversed += 180;
            if (beforeReversed > 360)
            {
                beforeReversed -= 360;
            }
            return beforeReversed;
        }  
        else
        {
            int xDiff = oldX - getX(),  
            yDiff = oldY - getY();  
            double angle = Math.toDegrees(Math.atan2(yDiff, xDiff));  
            int beforeReversed = (int)Math.round(angle);
            beforeReversed += 180;
            if (beforeReversed > 360)
            {
                beforeReversed -= 360;
            }
            return beforeReversed;
        }        
        
    } 

    /**
     * checks if we have a current target (for mouse x / mouse y) and finds the distance between
     * particle and mouse cursor.
     * 
     * erratic behaviour when mouse is not moving, hence multiple staements
     * 
    **/
    public void findDistance()
    {
        if(target != null)  
        {         
            newDistance = Math.sqrt(Math.pow((getX()- mySize / 2) - target.getY(),2)
                + Math.pow((getY() - mySize / 2)- target.getY(),2)) / 20;
        }
        if(target == null)  
        {         
            newDistance = Math.sqrt(Math.pow((getX()- mySize / 2) - oldX,2)
                + Math.pow((getY() - mySize / 2)- oldY,2)) / 20;
        }

    }

    /**
     * breaks myColor down into 4 variables so we can manipulate them individually
     * right now, we simply reduce the alpha by 10, until it bottoms out, then we 
     * bring it back up again
     * 
     * note: if act() removes this object before the alpha can be brought up again,
     * there is no need for an else statement
     */
    public void fade()
    {
        int r = myColor.getRed();
        int g = myColor.getGreen();
        int b = myColor.getBlue();
        int a = myColor.getAlpha();

        if (myColor.getAlpha() >= 10)
        {
            myColor = new Color(r,g,b, a - 2);
        }
        else
        {
            myColor = new Color(r,g,b,120);
        }
        image.setColor(myColor);
        image.fillOval(100 - mySize / 2 , 100 - mySize / 2 ,mySize,mySize);
    }
    /**
     * method is called from act, and draws to the background
     */
    public void drawOnBG()
    {
        bgImage = getWorld().getBackground();
        
        bgImage.setColor(myColor);
        bgImage.fillOval(getX(), getY(),mySize,mySize);
        
        
    }
    public boolean atWorldEdge()
    {
        if(getX() < 10 
        ||getY() < 19     
        || getX() > getWorld().getWidth() - 2
        ||getY() > getWorld().getHeight() - 2)
        {
            return true;
        }   
        else
        {
            return false;
        }
    }    

}
